enum R4Types {
  account,
  activitydefinition,
  adverseevent,
  allergyintolerance,
  appointment,
  appointmentresponse,
  auditevent,
  basic,
  binary,
  biologicallyderivedproduct,
  bodystructure,
  bundle,
  capabilitystatement,
  careplan,
  careteam,
  catalogentry,
  chargeitem,
  chargeitemdefinition,
  claim,
  claimresponse,
  clinicalimpression,
  codesystem,
  communication,
  communicationrequest,
  compartmentdefinition,
  composition,
  conceptmap,
  condition,
  consent,
  contract,
  coverage,
  coverageeligibilityrequest,
  coverageeligibilityresponse,
  detectedissue,
  device,
  devicedefinition,
  devicemetric,
  devicerequest,
  deviceusestatement,
  diagnosticreport,
  documentmanifest,
  documentreference,
  effectevidencesynthesis,
  encounter,
  endpoint,
  enrollmentrequest,
  enrollmentresponse,
  episodeofcare,
  eventdefinition,
  evidence,
  evidencevariable,
  examplescenario,
  explanationofbenefit,
  familymemberhistory,
  flag,
  goal,
  graphdefinition,
  group,
  guidanceresponse,
  healthcareservice,
  imagingstudy,
  immunization,
  immunizationevaluation,
  immunizationrecommendation,
  implementationguide,
  insuranceplan,
  invoice,
  library,
  linkage,
  list_,
  location,
  measure,
  measurereport,
  media,
  medication,
  medicationadministration,
  medicationdispense,
  medicationknowledge,
  medicationrequest,
  medicationstatement,
  medicinalproduct,
  medicinalproductauthorization,
  medicinalproductcontraindication,
  medicinalproductindication,
  medicinalproductingredient,
  medicinalproductinteraction,
  medicinalproductmanufactured,
  medicinalproductpackaged,
  medicinalproductpharmaceutical,
  medicinalproductundesirableeffect,
  messagedefinition,
  messageheader,
  molecularsequence,
  namingsystem,
  nutritionorder,
  observation,
  observationdefinition,
  operationdefinition,
  operationoutcome,
  organization,
  organizationaffiliation,
  parameters,
  patient,
  paymentnotice,
  paymentreconciliation,
  person,
  plandefinition,
  practitioner,
  practitionerrole,
  procedure,
  provenance,
  questionnaire,
  questionnaireresponse,
  relatedperson,
  requestgroup,
  researchdefinition,
  researchelementdefinition,
  researchstudy,
  researchsubject,
  riskassessment,
  riskevidencesynthesis,
  schedule,
  searchparameter,
  servicerequest,
  slot,
  specimen,
  specimendefinition,
  structuredefinition,
  structuremap,
  subscription,
  substance,
  substancenucleicacid,
  substancepolymer,
  substanceprotein,
  substancereferenceinformation,
  substancesourcematerial,
  substancespecification,
  supplydelivery,
  supplyrequest,
  task,
  terminologycapabilities,
  testreport,
  testscript,
  valueset,
  verificationresult,
  visionprescription,
  none,
  any,
}

const R4TypesEnumMap = {
  R4Types.account: 'Account',
  R4Types.activitydefinition: 'ActivityDefinition',
  R4Types.adverseevent: 'AdverseEvent',
  R4Types.allergyintolerance: 'AllergyIntolerance',
  R4Types.appointment: 'Appointment',
  R4Types.appointmentresponse: 'AppointmentResponse',
  R4Types.auditevent: 'AuditEvent',
  R4Types.basic: 'Basic',
  R4Types.binary: 'Binary',
  R4Types.biologicallyderivedproduct: 'BiologicallyDerivedProduct',
  R4Types.bodystructure: 'BodyStructure',
  R4Types.bundle: 'Bundle',
  R4Types.capabilitystatement: 'CapabilityStatement',
  R4Types.careplan: 'CarePlan',
  R4Types.careteam: 'CareTeam',
  R4Types.catalogentry: 'CatalogEntry',
  R4Types.chargeitem: 'ChargeItem',
  R4Types.chargeitemdefinition: 'ChargeItemDefinition',
  R4Types.claim: 'Claim',
  R4Types.claimresponse: 'ClaimResponse',
  R4Types.clinicalimpression: 'ClinicalImpression',
  R4Types.codesystem: 'CodeSystem',
  R4Types.communication: 'Communication',
  R4Types.communicationrequest: 'CommunicationRequest',
  R4Types.compartmentdefinition: 'CompartmentDefinition',
  R4Types.composition: 'Composition',
  R4Types.conceptmap: 'ConceptMap',
  R4Types.condition: 'Condition',
  R4Types.consent: 'Consent',
  R4Types.contract: 'Contract',
  R4Types.coverage: 'Coverage',
  R4Types.coverageeligibilityrequest: 'CoverageEligibilityRequest',
  R4Types.coverageeligibilityresponse: 'CoverageEligibilityResponse',
  R4Types.detectedissue: 'DetectedIssue',
  R4Types.device: 'Device',
  R4Types.devicedefinition: 'DeviceDefinition',
  R4Types.devicemetric: 'DeviceMetric',
  R4Types.devicerequest: 'DeviceRequest',
  R4Types.deviceusestatement: 'DeviceUseStatement',
  R4Types.diagnosticreport: 'DiagnosticReport',
  R4Types.documentmanifest: 'DocumentManifest',
  R4Types.documentreference: 'DocumentReference',
  R4Types.effectevidencesynthesis: 'EffectEvidenceSynthesis',
  R4Types.encounter: 'Encounter',
  R4Types.endpoint: 'Endpoint',
  R4Types.enrollmentrequest: 'EnrollmentRequest',
  R4Types.enrollmentresponse: 'EnrollmentResponse',
  R4Types.episodeofcare: 'EpisodeOfCare',
  R4Types.eventdefinition: 'EventDefinition',
  R4Types.evidence: 'Evidence',
  R4Types.evidencevariable: 'EvidenceVariable',
  R4Types.examplescenario: 'ExampleScenario',
  R4Types.explanationofbenefit: 'ExplanationOfBenefit',
  R4Types.familymemberhistory: 'FamilyMemberHistory',
  R4Types.flag: 'Flag',
  R4Types.goal: 'Goal',
  R4Types.graphdefinition: 'GraphDefinition',
  R4Types.group: 'Group',
  R4Types.guidanceresponse: 'GuidanceResponse',
  R4Types.healthcareservice: 'HealthcareService',
  R4Types.imagingstudy: 'ImagingStudy',
  R4Types.immunization: 'Immunization',
  R4Types.immunizationevaluation: 'ImmunizationEvaluation',
  R4Types.immunizationrecommendation: 'ImmunizationRecommendation',
  R4Types.implementationguide: 'ImplementationGuide',
  R4Types.insuranceplan: 'InsurancePlan',
  R4Types.invoice: 'Invoice',
  R4Types.library: 'Library',
  R4Types.linkage: 'Linkage',
  R4Types.list_: 'List',
  R4Types.location: 'Location',
  R4Types.measure: 'Measure',
  R4Types.measurereport: 'MeasureReport',
  R4Types.media: 'Media',
  R4Types.medication: 'Medication',
  R4Types.medicationadministration: 'MedicationAdministration',
  R4Types.medicationdispense: 'MedicationDispense',
  R4Types.medicationknowledge: 'MedicationKnowledge',
  R4Types.medicationrequest: 'MedicationRequest',
  R4Types.medicationstatement: 'MedicationStatement',
  R4Types.medicinalproduct: 'MedicinalProduct',
  R4Types.medicinalproductauthorization: 'MedicinalProductAuthorization',
  R4Types.medicinalproductcontraindication: 'MedicinalProductContraindication',
  R4Types.medicinalproductindication: 'MedicinalProductIndication',
  R4Types.medicinalproductingredient: 'MedicinalProductIngredient',
  R4Types.medicinalproductinteraction: 'MedicinalProductInteraction',
  R4Types.medicinalproductmanufactured: 'MedicinalProductManufactured',
  R4Types.medicinalproductpackaged: 'MedicinalProductPackaged',
  R4Types.medicinalproductpharmaceutical: 'MedicinalProductPharmaceutical',
  R4Types.medicinalproductundesirableeffect:
      'MedicinalProductUndesirableEffect',
  R4Types.messagedefinition: 'MessageDefinition',
  R4Types.messageheader: 'MessageHeader',
  R4Types.molecularsequence: 'MolecularSequence',
  R4Types.namingsystem: 'NamingSystem',
  R4Types.nutritionorder: 'NutritionOrder',
  R4Types.observation: 'Observation',
  R4Types.observationdefinition: 'ObservationDefinition',
  R4Types.operationdefinition: 'OperationDefinition',
  R4Types.operationoutcome: 'OperationOutcome',
  R4Types.organization: 'Organization',
  R4Types.organizationaffiliation: 'OrganizationAffiliation',
  R4Types.parameters: 'Parameters',
  R4Types.patient: 'Patient',
  R4Types.paymentnotice: 'PaymentNotice',
  R4Types.paymentreconciliation: 'PaymentReconciliation',
  R4Types.person: 'Person',
  R4Types.plandefinition: 'PlanDefinition',
  R4Types.practitioner: 'Practitioner',
  R4Types.practitionerrole: 'PractitionerRole',
  R4Types.procedure: 'Procedure',
  R4Types.provenance: 'Provenance',
  R4Types.questionnaire: 'Questionnaire',
  R4Types.questionnaireresponse: 'QuestionnaireResponse',
  R4Types.relatedperson: 'RelatedPerson',
  R4Types.requestgroup: 'RequestGroup',
  R4Types.researchdefinition: 'ResearchDefinition',
  R4Types.researchelementdefinition: 'ResearchElementDefinition',
  R4Types.researchstudy: 'ResearchStudy',
  R4Types.researchsubject: 'ResearchSubject',
  R4Types.riskassessment: 'RiskAssessment',
  R4Types.riskevidencesynthesis: 'RiskEvidenceSynthesis',
  R4Types.schedule: 'Schedule',
  R4Types.searchparameter: 'SearchParameter',
  R4Types.servicerequest: 'ServiceRequest',
  R4Types.slot: 'Slot',
  R4Types.specimen: 'Specimen',
  R4Types.specimendefinition: 'SpecimenDefinition',
  R4Types.structuredefinition: 'StructureDefinition',
  R4Types.structuremap: 'StructureMap',
  R4Types.subscription: 'Subscription',
  R4Types.substance: 'Substance',
  R4Types.substancenucleicacid: 'SubstanceNucleicAcid',
  R4Types.substancepolymer: 'SubstancePolymer',
  R4Types.substanceprotein: 'SubstanceProtein',
  R4Types.substancereferenceinformation: 'SubstanceReferenceInformation',
  R4Types.substancesourcematerial: 'SubstanceSourceMaterial',
  R4Types.substancespecification: 'SubstanceSpecification',
  R4Types.supplydelivery: 'SupplyDelivery',
  R4Types.supplyrequest: 'SupplyRequest',
  R4Types.task: 'Task',
  R4Types.terminologycapabilities: 'TerminologyCapabilities',
  R4Types.testreport: 'TestReport',
  R4Types.testscript: 'TestScript',
  R4Types.valueset: 'ValueSet',
  R4Types.verificationresult: 'VerificationResult',
  R4Types.visionprescription: 'VisionPrescription',
  R4Types.none: '',
  R4Types.any: '*',
};
